import { FormixOptions, UseFormixReturnType } from "./useFormix";
import { ArrayShift, ValidateFn } from "../types";
declare type FieldSchema<T> = {
    field: T;
};
export declare type UseFieldReturnType<T> = {
    [K in keyof Omit<UseFormixReturnType<FieldSchema<T>>, "getErrors" | "getError" | "getValues" | "setValues" | "setErrors">]: (...params: ArrayShift<Parameters<UseFormixReturnType<FieldSchema<T>>[K]>>) => ReturnType<UseFormixReturnType<FieldSchema<T>>[K]>;
};
export declare function useField<T>(value: T, { validate, ...options }?: Omit<FormixOptions<FieldSchema<T>>, "validates"> & {
    validate?: ValidateFn;
}): UseFieldReturnType<T>;
export {};
