'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var isEqual = _interopDefault(require('react-fast-compare'));
var mobx = require('mobx');
var mobxReactLite = require('mobx-react-lite');
var FastestValidator = _interopDefault(require('fastest-validator'));

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it) return (it = it.call(o)).next.bind(it);

  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it) o = it;
    var i = 0;
    return function () {
      if (i >= o.length) return {
        done: true
      };
      return {
        done: false,
        value: o[i++]
      };
    };
  }

  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = GeneratorFunctionPrototype;
  define(Gp, "constructor", GeneratorFunctionPrototype);
  define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  });
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  define(Gp, iteratorSymbol, function() {
    return this;
  });

  define(Gp, "toString", function() {
    return "[object Generator]";
  });

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, in modern engines
  // we can explicitly access globalThis. In older engines we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  if (typeof globalThis === "object") {
    globalThis.regeneratorRuntime = runtime;
  } else {
    Function("r", "regeneratorRuntime = r")(runtime);
  }
}
});

function deepEntries(object, conditionFn) {
  var keys = Object.keys(object);
  var entries = [];

  var _loop = function _loop() {
    var key = _keys[_i];
    var value = object[key];
    entries.push([key, value]);

    if (typeof value === "object" && (!conditionFn || conditionFn(key, value))) {
      var subEntires = deepEntries(value, conditionFn);
      entries.push.apply(entries, subEntires.map(function (_ref) {
        var entryKey = _ref[0],
            value = _ref[1];
        return [key + "." + entryKey, value];
      }));
    }
  };

  for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
    _loop();
  }

  return entries;
}

function isFunction(value) {
  return typeof value === "function";
}
function debounce(callback, time) {
  var timeout;
  if (time <= 0) return callback;
  return function () {
    var _this = this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var effect = function effect() {
      timeout = null;
      return callback.apply(_this, args);
    };

    clearTimeout(timeout);
    timeout = setTimeout(effect, time);
  };
}
function isArray(value) {
  return Array.isArray(value);
}
function mergeRefs() {
  for (var _len2 = arguments.length, refs = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    refs[_key2] = arguments[_key2];
  }

  var filteredRefs = refs.filter(Boolean);

  if (filteredRefs.length === 0) {
    return undefined;
  }

  return function (instance) {
    for (var _iterator = _createForOfIteratorHelperLoose(filteredRefs), _step; !(_step = _iterator()).done;) {
      var ref = _step.value;

      if (typeof ref === "function") {
        ref(instance);
      } else if (ref) {
        ref.current = instance;
      }
    }
  };
}

var emptyFunction = function emptyFunction() {};

function mergeCallbacks() {
  for (var _len3 = arguments.length, callbacks = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    callbacks[_key3] = arguments[_key3];
  }

  var filteredCallbacks = callbacks.filter(Boolean);

  if (filteredCallbacks.length === 0) {
    return emptyFunction;
  }

  return function () {
    for (var _iterator2 = _createForOfIteratorHelperLoose(filteredCallbacks), _step2; !(_step2 = _iterator2()).done;) {
      var callback = _step2.value;
      callback.apply(void 0, arguments);
    }
  };
}
function safeNumber(number) {
  number = Number(number);
  return !Number.isFinite(number) ? 0 : number;
}

function removeDuplicates(array) {
  return Array.from(new Set(array));
}

function removeUnmountedElements(elements) {
  return elements.filter(function (element) {
    return document.body.contains(element);
  });
}
function isSelectElement(element) {
  return element.tagName.toLowerCase() === "select";
}
function isTextAreaElement(element) {
  return element.tagName.toLocaleLowerCase() === "textarea";
}
function isInputElement(element) {
  return element.tagName.toLocaleLowerCase() === "input";
}

var CHECKED_INPUT_TYPES = ["radio", "checkbox"];
function syncFieldsValues(fields, value) {
  if (Array.isArray(value)) {
    fields.forEach(function (field) {
      if (isSelectElement(field)) {
        field.querySelectorAll("option").forEach(function (option) {
          return option.selected = value.includes(option.value);
        });
      } else if (isInputElement(field) || isTextAreaElement(field)) {
        if (isInputElement(field) && CHECKED_INPUT_TYPES.includes(field.type)) {
          field.checked = value.includes(field.value);
        } else {
          field.value = value[0] || "";
        }
      }
    });
  } else if (typeof value === "boolean") {
    fields.forEach(function (field) {
      if (isInputElement(field)) {
        field.checked = value;
      }
    });
  } else {
    fields.forEach(function (field) {
      if (isSelectElement(field)) {
        field.querySelectorAll("option").forEach(function (option) {
          return option.selected = value === option.value;
        });
      } else if (isInputElement(field) && CHECKED_INPUT_TYPES.includes(field.type)) {
        field.checked = field.value === value;
      } else if (isInputElement(field) || isTextAreaElement(field)) {
        field.value = String(value);
      }
    });
  }
}
function collectFieldsValues(field, value) {
  var collectedValue = value;

  if (Array.isArray(value)) {
    if (isSelectElement(field)) {
      var selectedOptionsValues = Array.from(field.selectedOptions).map(function (option) {
        return option.value;
      });
      collectedValue = removeDuplicates(selectedOptionsValues);
    } else if (isInputElement(field) && CHECKED_INPUT_TYPES.includes(field.type)) {
      collectedValue = removeDuplicates(field.checked ? [].concat(value, [String(field.value)]) : value.filter(function (value) {
        return value !== field.value;
      }));
    } else if (isInputElement(field) || isTextAreaElement(field)) {
      var _field$value;

      collectedValue = [(_field$value = field.value) != null ? _field$value : ""];
    }
  } else if (typeof value === "boolean" && isInputElement(field)) {
    collectedValue = Boolean(field.checked);
  } else {
    collectedValue = field.value;
  }

  if (typeof value === "boolean") {
    collectedValue = Array.isArray(collectedValue) ? collectedValue.map(Boolean) : Boolean(collectedValue);
  } else if (typeof value === "number") {
    collectedValue = Array.isArray(collectedValue) ? collectedValue.map(safeNumber) : safeNumber(collectedValue);
  }

  return collectedValue;
}
function validateFactory(validateFn) {
  return validateFn;
}

function isFormValue(value) {
  return Array.isArray(value) || ["string", "number", "boolean"].includes(typeof value);
}

function compileFormSchema(schema) {
  var entries = deepEntries(schema, function (_, value) {
    return !isFormValue(value);
  });
  var fields = entries.filter(function (_ref2) {
    var value = _ref2[1];
    return isFormValue(value);
  }).map(function (_ref3) {
    var key = _ref3[0],
        value = _ref3[1];
    return [key, value];
  });
  var groups = entries.filter(function (_ref4) {
    var entryKey = _ref4[0];
    return fields.every(function (_ref5) {
      var key = _ref5[0];
      return key !== entryKey;
    });
  }).map(function (_ref6) {
    var entryKey = _ref6[0];
    return [entryKey + ".*", fields.filter(function (_ref7) {
      var key = _ref7[0];
      return key.includes(entryKey);
    }).map(function (_ref8) {
      var key = _ref8[0];
      return key;
    })];
  });
  return {
    fields: fields.reduce(function (acc, _ref9) {
      var _extends2;

      var name = _ref9[0],
          value = _ref9[1];
      return _extends({}, acc, (_extends2 = {}, _extends2[name] = value, _extends2));
    }, {}),
    groups: groups.reduce(function (acc, _ref10) {
      var _extends3;

      var name = _ref10[0],
          value = _ref10[1];
      return _extends({}, acc, (_extends3 = {}, _extends3[name] = value, _extends3));
    }, {})
  };
}

function useLocalStore(schema) {
  return mobxReactLite.useLocalObservable(function () {
    return schema;
  });
}

function usePrevious(value) {
  var ref = React.useRef(value);
  React.useEffect(function () {
    ref.current = value;
  }, [value]);
  return ref.current;
}

function useEvent(callback) {
  var callbackRef = React.useRef(null);
  React.useLayoutEffect(function () {
    callbackRef.current = callback;
  });
  return React.useCallback(function () {
    return callbackRef.current.apply(callbackRef, arguments);
  }, []);
}

function useDebounce(callback, time) {
  return useEvent(debounce(callback, time));
}

var formixContext = /*#__PURE__*/React.createContext(null);
var delimiter = "%%$$%%";
function useFormix(schema, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      _ref$validateAfterMou = _ref.validateAfterMount,
      validateAfterMount = _ref$validateAfterMou === void 0 ? true : _ref$validateAfterMou,
      _ref$resetErrorAfterI = _ref.resetErrorAfterInput,
      resetErrorAfterInput = _ref$resetErrorAfterI === void 0 ? true : _ref$resetErrorAfterI,
      _ref$formValidationDe = _ref.formValidationDebounceTime,
      formValidationDebounceTime = _ref$formValidationDe === void 0 ? 100 : _ref$formValidationDe,
      _ref$validates = _ref.validates,
      validates = _ref$validates === void 0 ? {} : _ref$validates;

  var previousSchema = usePrevious(schema);
  var cachedCompiledSchemaRef = React.useRef(null);
  var compiledSchema = React.useMemo(function () {
    var areEqual = isEqual(previousSchema, schema);
    var compiledSchema = cachedCompiledSchemaRef.current;

    if (!compiledSchema || !areEqual) {
      compiledSchema = compileFormSchema(schema);
      cachedCompiledSchemaRef.current = compiledSchema;
    }

    return compiledSchema;
  }, [previousSchema, schema]);
  var fields = compiledSchema.fields;
  var groups = compiledSchema.groups;
  var fieldsHash = React.useMemo(function () {
    return Object.keys(fields).join(delimiter);
  }, [fields]);
  var fieldsNames = React.useMemo(function () {
    return fieldsHash.split(delimiter);
  }, [fieldsHash]);
  var validatesRef = React.useRef(validates);
  var validatorsRef = React.useRef(validates);
  var formElementsRef = React.useRef({});
  var localStore = useLocalStore({
    values: _extends({}, fields),
    errors: {},
    isFormValid: false,
    setValue: function setValue(name, value) {
      this.values[name] = value;
    },
    setValues: function setValues(values) {
      this.values = values;
    },
    setError: function setError(name, value) {
      this.errors[name] = value;
    },
    setErrors: function setErrors(value) {
      this.errors = value;
    },
    setIsFormValid: function setIsFormValid(value) {
      this.isFormValid = value;
    }
  });
  var getValue = React.useCallback(function (name) {
    var _localStore$values$na;

    return (_localStore$values$na = localStore.values[name]) != null ? _localStore$values$na : "";
  }, [localStore]);
  var getValues = React.useCallback(function () {
    return _extends({}, localStore.values);
  }, [localStore]);
  var connectFormElement = React.useCallback(function (name, element) {
    var formElements = formElementsRef.current;

    if (!formElements[name]) {
      formElements[name] = [];
    }

    var elements = formElements[name];
    if (!elements) return;

    if (element && isArray(elements)) {
      elements.push(element);
    }

    formElements[name] = removeDuplicates(removeUnmountedElements(elements));
  }, []);
  var syncFormFields = React.useCallback(function (name, value) {
    var formElements = formElementsRef.current;
    var elements = formElements[name];

    if (elements && elements.length) {
      syncFieldsValues(elements, value);
    }
  }, []);
  var setValue = React.useCallback(function (name, valueOrCallback, sync) {
    if (sync === void 0) {
      sync = true;
    }

    var value = isFunction(valueOrCallback) ? valueOrCallback(getValue(name)) : valueOrCallback;
    localStore.setValue(name, value);

    if (sync) {
      syncFormFields(name, value);
    }
  }, [getValue, localStore, syncFormFields]);
  var setValues = React.useCallback(function (values, sync) {
    if (sync === void 0) {
      sync = true;
    }

    var schemaWithUpdatedValues = compileFormSchema(values).fields;
    localStore.setValues(_extends({}, localStore.values, schemaWithUpdatedValues));

    if (sync) {
      var keys = Object.keys(schemaWithUpdatedValues);
      keys.forEach(function (key) {
        return syncFormFields(key, schemaWithUpdatedValues[key]);
      });
    }
  }, [localStore, syncFormFields]);
  var setError = React.useCallback(function (name, error) {
    localStore.setError(name, error);
  }, [localStore]);
  var getError = React.useCallback(function (name) {
    var _localStore$errors$na;

    return (_localStore$errors$na = localStore.errors[name]) != null ? _localStore$errors$na : "";
  }, [localStore]);
  var bind = React.useCallback(function (name, options) {
    if (options === void 0) {
      options = {};
    }

    return {
      ref: mergeRefs(options.ref, function (element) {
        if (options.validate && element) {
          validatorsRef.current[name] = options.validate;
        } else if (!validatorsRef.current[name]) {
          validatorsRef.current[name] = null;
        } else {
          var _validatesRef$current;

          validatorsRef.current[name] = (_validatesRef$current = validatesRef.current[name]) != null ? _validatesRef$current : null;
        }

        connectFormElement(name, element);
        syncFormFields(name, getValue(name));
      }),
      onChange: mergeCallbacks(function (event) {
        var field = event.target;
        var value = collectFieldsValues(field, getValue(name));

        if (resetErrorAfterInput) {
          setError(name, "");
        }

        setValue(name, value);
      }, options.onChange)
    };
  }, [connectFormElement, syncFormFields, getValue, resetErrorAfterInput, setValue, setError]);
  var getValidationErrors = React.useCallback( /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(target) {
      var fields, defaultErrors, validates, isValidatesNotEmpty, _fieldsNames, validatesPromises, validatesResults, haveSomeErrors;

      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              fields = target ? groups[target] : fieldsNames;
              defaultErrors = fields.reduce(function (acc, key) {
                var _extends2;

                return _extends({}, acc, (_extends2 = {}, _extends2[key] = "", _extends2));
              }, {});
              validates = Object.entries(validatorsRef.current).filter(function (_ref3) {
                var key = _ref3[0],
                    value = _ref3[1];
                return fields.includes(key) && value;
              });
              isValidatesNotEmpty = validates.length > 0;

              if (!isValidatesNotEmpty) {
                _context.next = 13;
                break;
              }

              _fieldsNames = validates.map(function (_ref4) {
                var key = _ref4[0];
                return key;
              });
              validatesPromises = _fieldsNames.map(function (name) {
                return validatorsRef.current[name](getValue(name), {
                  name: name
                });
              });
              _context.next = 9;
              return Promise.allSettled(validatesPromises);

            case 9:
              validatesResults = _context.sent;
              haveSomeErrors = validatesResults.some(function (result) {
                return result.value;
              });

              if (!haveSomeErrors) {
                _context.next = 13;
                break;
              }

              return _context.abrupt("return", _extends({}, defaultErrors, validatesResults.reduce(function (acc, result, index) {
                var _extends3;

                var name = _fieldsNames[index];
                return _extends({}, acc, (_extends3 = {}, _extends3[name] = result.value ? String(result.value) : undefined, _extends3));
              }, {})));

            case 13:
              return _context.abrupt("return", defaultErrors);

            case 14:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }(), [fieldsNames, getValue, groups]);
  var validate = React.useCallback( /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(target) {
      var errors, fieldsEntries;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return getValidationErrors(target);

            case 2:
              errors = _context2.sent;
              fieldsEntries = Object.entries(errors);
              localStore.setErrors(_extends({}, localStore.errors, errors));

              if (!fieldsEntries.filter(function (_ref6) {
                var value = _ref6[1];
                return value;
              }).length) {
                _context2.next = 7;
                break;
              }

              return _context2.abrupt("return", false);

            case 7:
              return _context2.abrupt("return", true);

            case 8:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x2) {
      return _ref5.apply(this, arguments);
    };
  }(), [getValidationErrors, localStore]);
  var isValid = React.useCallback( /*#__PURE__*/function () {
    var _ref7 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee3(target) {
      var errors, fieldsEntries;
      return runtime_1.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return getValidationErrors(target);

            case 2:
              errors = _context3.sent;
              fieldsEntries = Object.entries(errors);
              return _context3.abrupt("return", fieldsEntries.filter(function (_ref8) {
                var value = _ref8[1];
                return value;
              }).length === 0);

            case 5:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x3) {
      return _ref7.apply(this, arguments);
    };
  }(), [getValidationErrors]);
  var setErrors = React.useCallback(function (errors) {
    localStore.setErrors(_extends({}, localStore.errors, errors));
  }, [localStore]);
  var resetErrors = React.useCallback(function (target) {
    var fields = target ? groups[target] : fieldsNames;
    localStore.setErrors(_extends({}, localStore.errors, fields.reduce(function (acc, key) {
      var _extends4;

      return _extends({}, acc, (_extends4 = {}, _extends4[key] = "", _extends4));
    }, {})));
  }, [fieldsNames, groups, localStore]);
  var resetValues = React.useCallback(function () {
    setValues(fields);
  }, [fields, setValues]);
  var reset = React.useCallback(function () {
    resetValues();
    resetErrors();
  }, [resetErrors, resetValues]);
  var haveError = React.useCallback(function (name) {
    return Boolean(getError(name));
  }, [getError]);
  var updateIsFormValid = React.useCallback( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee4() {
    var valid;
    return runtime_1.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return isValid();

          case 2:
            valid = _context4.sent;
            localStore.setIsFormValid(valid);

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })), [isValid, localStore]);
  var autoValidation = useDebounce(function () {
    if (formValidationDebounceTime) {
      updateIsFormValid();
    }
  }, formValidationDebounceTime);
  var getIsFormValid = React.useCallback(function () {
    return localStore.isFormValid;
  }, [localStore]);
  React.useEffect(function () {
    validatesRef.current = validates;
  }, [validates]);
  React.useEffect(function () {
    if (!isEqual(schema, previousSchema)) {
      reset();
    }
  }, [schema, previousSchema, reset]);
  React.useEffect(function () {
    if (validateAfterMount) {
      validate();
      updateIsFormValid();
    }
  }, [validateAfterMount, validate, autoValidation, updateIsFormValid]);
  React.useEffect(function () {
    return mobx.reaction(function () {
      return getValues();
    }, autoValidation);
  }, [autoValidation, getValues, localStore]);
  var formixInterface = React.useMemo(function () {
    return {
      bind: bind,
      setValue: setValue,
      getValue: getValue,
      getValues: getValues,
      setValues: setValues,
      setErrors: setErrors,
      validate: validate,
      reset: reset,
      isValid: isValid,
      setError: setError,
      getError: getError,
      haveError: haveError,
      resetValues: resetValues,
      resetErrors: resetErrors,
      getIsFormValid: getIsFormValid
    };
  }, [bind, getError, getIsFormValid, getValue, getValues, haveError, isValid, reset, resetErrors, resetValues, setError, setErrors, setValue, setValues, validate]);
  var ContextProvider = React.useCallback(function (_ref10) {
    var children = _ref10.children;
    return React__default.createElement(formixContext.Provider, {
      value: formixInterface
    }, children);
  }, [formixInterface]);
  return React.useMemo(function () {
    return _extends({}, formixInterface, {
      ContextProvider: ContextProvider
    });
  }, [formixInterface, ContextProvider]);
}

var _excluded = ["validate"];
function useField(value, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      validate = _ref.validate,
      options = _objectWithoutPropertiesLoose(_ref, _excluded);

  var formix = useFormix({
    field: value
  }, _extends({}, options, {
    validates: {
      field: validate != null ? validate : null
    }
  }));
  return React.useMemo(function () {
    return {
      ContextProvider: formix.ContextProvider,
      getValue: function getValue() {
        return formix.getValue("field");
      },
      setValue: function setValue(value) {
        return formix.setValue("field", value);
      },
      setError: function setError(error) {
        return formix.setError("field", error);
      },
      reset: function reset() {
        return formix.reset();
      },
      resetErrors: function resetErrors() {
        return formix.resetErrors();
      },
      resetValues: function resetValues() {
        return formix.resetErrors();
      },
      bind: function bind(options) {
        return formix.bind("field", options);
      },
      validate: function validate() {
        return formix.validate();
      },
      isValid: function isValid() {
        return formix.isValid();
      },
      getIsFormValid: function getIsFormValid() {
        return formix.getIsFormValid();
      },
      haveError: function haveError() {
        return formix.haveError("field");
      }
    };
  }, [formix]);
}

var fastestValidator = /*#__PURE__*/new FastestValidator();
var plugFieldName = "__formix_field__";
var replaceRegexp = /*#__PURE__*/new RegExp(plugFieldName, "g");
var fastestValidate = /*#__PURE__*/validateFactory(function (rule, options) {
  var _compile;

  if (options === void 0) {
    options = {};
  }

  var check = (options.validator || fastestValidator).compile((_compile = {
    $$async: true
  }, _compile[plugFieldName] = rule, _compile));
  return /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(value, _ref) {
      var _check, _options$name;

      var name, result, message;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              name = _ref.name;
              _context.next = 3;
              return check((_check = {}, _check[plugFieldName] = value, _check));

            case 3:
              result = _context.sent;

              if (!(result === true || !result.length)) {
                _context.next = 6;
                break;
              }

              return _context.abrupt("return", "");

            case 6:
              message = result[0].message;
              return _context.abrupt("return", message && name ? message.replace(replaceRegexp, (_options$name = options.name) != null ? _options$name : name) : message);

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();
});

var joiValidate = /*#__PURE__*/validateFactory(function (schema) {
  return /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(value) {
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;

              if (!(schema != null && schema.validateAsync)) {
                _context.next = 4;
                break;
              }

              _context.next = 4;
              return schema.validateAsync(value);

            case 4:
              return _context.abrupt("return", "");

            case 7:
              _context.prev = 7;
              _context.t0 = _context["catch"](0);
              return _context.abrupt("return", (_context.t0 == null ? void 0 : _context.t0.message) || "");

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 7]]);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();
});

var _excluded$1 = ["onSubmit"];
var Form = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var onSubmit = _ref.onSubmit,
      rest = _objectWithoutPropertiesLoose(_ref, _excluded$1);

  var handleSubmit = React.useCallback(function (event) {
    event.preventDefault();
  }, []);
  return React__default.createElement("form", Object.assign({
    ref: ref,
    noValidate: true
  }, rest, {
    onSubmit: mergeCallbacks(handleSubmit, onSubmit)
  }));
});

exports.Form = Form;
exports.fastestValidate = fastestValidate;
exports.joiValidate = joiValidate;
exports.useField = useField;
exports.useFormix = useFormix;
//# sourceMappingURL=react-formix.cjs.development.js.map
